#ifndef VAN_GENUCHTEN_RETEN_H
#define VAN_GENUCHTEN_RETEN_H

#include "genfile.h"

/**
   This class defines retention curve of Van_Genuchten and Schrefler's model
*/

class van_genuchten_reten
{
 public:
  van_genuchten_reten();    //constructor
  ~van_genuchten_reten();   //destructor

  void read(XFILE *in);
  void print(FILE *out);

  double sw(double pw);
  double dsw_dpw(double pw);
  double dsw_dt(double pw);
  double krw(double pw);
  double get_k(double pw);

 private:
  double ssat,sirr,ksat,gamaw,delta,expn,expm;

};  

#endif
